#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"

#include <stdio.h>
#include <stdarg.h>
#include <malloc.h>
#include "lib.h"
#include "iwram.h"
#include "syscall.h"

extern u8 __ewram_overlay_lma;
u8 *exttfs;

ST_FONTBITMAP FONTBITMAP;
ST_FONTSJIS   FONTSJIS;

int  wavecnt;
s8  *wavedata;
//========================================================================
void WaitForVsync(void){
  while (*(volatile u16*)0x4000006 >= 160){};
  while (*(volatile u16*)0x4000006 < 160) {};
}
//========================================================================
void Mode3PutPixel(u8 x,u8 y,u16 color){
  u16 *Screen = VideoBuffer;
  Screen[y*240+x] = color;
}
//========================================================================
void Mode3DrawImage(u8 cx,u8 cy,u16* image){
  u16* Screen = VideoBuffer;
  int x,y;

  for(y=0;y<cy;y++)
    for(x=0;x<cx;x++)
      Screen[y*240+x] = image[y*240+x];
}
//========================================================================
void Mode3DrawBox(u8 x1,u8 y1,u8 x2,u8 y2,u16 col){
  u16 *Screen = VideoBuffer;
  int x,y;
  
  for(y=y1; y<y2; y++)
    for(x=x1; x<x2; x++)
      Screen[y*240+x] = col;
}
//========================================================================
void DMA3MemcpyFIX16(u32 src, u32 dest, u16 size){
  REG_DM3SAD   = src;            //]
  REG_DM3DAD   = dest;           //]
  REG_DM3CNT_L = size;           //]TCY u16Pʂ̐
                                 //][h 16bit ]tOON 
                                 //]^C~OɊJn s[hOFF
                                 //]Œ ]CN
                                 //f[^]A荞ݒ~
  REG_DM3CNT_H = (DMA_SIZE_16    | DMA_TRANSFER_ON |
                  DMA_TIMING_NOW | DMA_REPEAT_OFF  |
                  DMA_SAD_FIX    | DMA_DAD_INC     | DMA_INTR_OFF);

  while(REG_IF&IRQ_BIT_DMA3){}    //DMA]tO~܂Ń[v
}
//========================================================================
void DMA3MemcpyINC16(u32 src, u32 dest, u16 size){
  REG_DM3SAD   = src;            //]
  REG_DM3DAD   = dest;           //]
  REG_DM3CNT_L = size;           //]TCY u16Pʂ̐
                                 //][h 16bit ]tOON 
                                 //]^C~OɊJn s[hOFF
                                 //]CN ]CN
                                 //f[^]A荞ݒ~
  REG_DM3CNT_H = (DMA_SIZE_16    | DMA_TRANSFER_ON |
                  DMA_TIMING_NOW | DMA_REPEAT_OFF  |
                  DMA_SAD_INC    | DMA_DAD_INC     | DMA_INTR_OFF);

  while(REG_IF&IRQ_BIT_DMA3){}    //DMA]tO~܂Ń[v
}
//========================================================================
void DMA3MemcpyINC32(u32 src, u32 dest, u16 size){
  REG_DM3SAD   = src;            //]
  REG_DM3DAD   = dest;           //]
  REG_DM3CNT_L = size;           //]TCY u16Pʂ̐
                                 //][h 16bit ]tOON 
                                 //]^C~OɊJn s[hOFF
                                 //]Œ ]CN
                                 //f[^]A荞ݒ~
  REG_DM3CNT_H = (DMA_SIZE_32    | DMA_TRANSFER_ON |
                  DMA_TIMING_NOW | DMA_REPEAT_OFF  |
                  DMA_SAD_INC    | DMA_DAD_INC     | DMA_INTR_OFF);

  while(REG_IF&IRQ_BIT_DMA3){}    //DMA]tO~܂Ń[v
}
//========================================================================
void Mode3SetBitMapFont(u8 *p, u16 cx, u16 cy, u16 cnt){
  FONTBITMAP.offset  = p;
  FONTBITMAP.cnt     = cnt;   //܂̂Ƃ͎gȂ
  FONTBITMAP.cx      = cx;
  FONTBITMAP.cy      = cy;
  FONTBITMAP.size    = cx*cy;
}
//========================================================================
void Mode3SetSJISFont(u32 code, u16 cnt, u32 offset, u8 cx, u8 cy){
  FONTSJIS.Code    = (u16*)exttfs_GetDataOffset(code);   //ƂȂtHgV[g
  FONTSJIS.Offset  = (u8 *)exttfs_GetDataOffset(offset); //tHgf[^
  FONTSJIS.cnt     = cnt/2;                              //tHg@u16Pʂ̏̂Ł`
  FONTSJIS.cx      = cx;                                 //PtHgx̃oCg
  FONTSJIS.cy      = cy;                                 //PtHgỹoCg
  FONTSJIS.size    = cx*cy;                              //PtHgByte
}
//========================================================================
void Mode3DrawChar(u8 x,u8 y,u16 chr){
  u16 *Screen = VideoBuffer;
  u16 *Offset = (u16*)FONTBITMAP.offset;
  int i,j;

  Screen += FONTBITMAP.cx*x + FONTBITMAP.cy*y*240;
  Offset += FONTBITMAP.size * chr;

  for(i=0; i<FONTBITMAP.cy; i++){
    for(j=0; j<FONTBITMAP.cx; j++){
      Screen[i*240+j] = *Offset++;
    }
  }
}
//========================================================================
void Mode3DrawStr(u8 x,u8 y,u8* str){
  u16 c;
  int i=0,dx=0;

  while(str[i]!=0x00 && str[i]!=0x0a){

    if(str[i]<=0x7f){ // 1byte char
      Mode3DrawChar(x+dx,y,(u16)str[i]);
      dx++; i++;
    }
    else {            // 2byte char
      switch(str[i]){
        case 0x82: c = str[i+1]-0x90+192; break;
        case 0x83: c = str[i+1]-0x40+304; break;
        default  : c = str[i+1];          break;
      }

      Mode3DrawChar(x+dx,y,c);
      dx++; i+=2;
    }
  }
}
//========================================================================
void Mode3DrawNumber(u8 x, u8 y, u32 num, u8 len){
  int i;
  for(i=0; i<len; i++){
      Mode3DrawChar(x+(len-i), y, num%10+0x30);
      num/=10;
  }
}
//========================================================================
void BGShowNumber(u8 BG, u8 x, u8 y, u32 num, u8 len){
  int i;
  for(i=0; i<len; i++){
    BGSetMap(BG, x+(len-i), y, 0, num%10+0x30);
    num/=10;
  }
}
//========================================================================
void BGSetChr(u8 No,u32 img,u16 size)
{
  u16 *BGChr = MEM_BG_CHAR(No);
  DMA3MemcpyINC32(img, (u32)BGChr, size/2);
}
//========================================================================
void BGSetMap(u8 No, u16 x,u16 y,u16 palno,u16 chr){
  u16 *BGMap = MEM_BG_MAP(No);
  BGMap += y*32+x;
  *BGMap = chr+(palno<<12);
}
//========================================================================
void BGSetPal(u32 pal){
  u16 *BGPal = MEM_BG_PAL;
  DMA3MemcpyINC32(pal, (u32)BGPal, 16/2);
}
//========================================================================
void BGDrawStr(u8 BG,u8 x,u8 y,u8* str){
  u16 c;
  int i,dx;
  
  dx=i=0;
  while(str[i]!=0x00 && str[i]!=0x0a){
    
    if(str[i]<=0x7f){ // 1bytechar
      BGSetMap(BG,x+dx,y,0,(u16)str[i]);
      dx++;
      i++;
    }
    else {            // 2bytechar
      c = str[i+1];
      if(str[i]==0x82){
        c = c-0x90+192;
      }
      if(str[i]==0x83){
        c = c-0x40+304;
      }
      BGSetMap(BG,x+dx,y,0,c);
      dx++;
      i+=2;
    }
  }
}
//========================================================================
void SpriteInitialize(){
  OAMEntry* sp = (OAMEntry*)OAMmem;      // OAM
  int i;
  for(i=0; i<128; i++){
    sp[i].attribute0 = 160;  //y to > 159 DisplaySize
    sp[i].attribute1 = 240;  //x to > 239
  }
}
//========================================================================
void SpriteMove(u16 num, s16 x, s16 y){
  OAMEntry* sp = (OAMEntry*)OAMmem;      // OAM
  sp += num;                             // OAM̍\Pʂ8byte
  if(x<0) x += 512;
  if(y<0) y += 256;
  sp->attribute1 &= 0xfe00;
  sp->attribute0 &= 0xff00;
  sp->attribute1 |= (x & 0x01ff);
  sp->attribute0 |= (y & 0x00ff);
}
//========================================================================
void SpriteSetPalNo(u16 num, u16 palno){
  OAMEntry* sp = (OAMEntry*)OAMmem;      // OAM
  sp += num;                             // OAM̍\Pʂ8byte
  sp->attribute2 &= 0x0fff;
  sp->attribute2 |= (palno<<12);
}
//========================================================================
/*	XvCǧ`ݒ
	spEEE ύXXvCgw
	sizeEE SP_SIZE_8,SP_SIZE_16,SP_SIZE_32,SP_SIZE_64
	formEE SP_SQUARE,SP_TALL,SP_WIDE
	colorEESP_COLOR_16, SP_COLOR_256  */
void SpriteSetSize(u16 num,u16 size,u16 form,u16 color){
  OAMEntry* sp = (OAMEntry*)OAMmem;      // OAM
  sp += num;                             // OAM̍\Pʂ8byte
  sp->attribute0 &= 0x1FFF;
  sp->attribute0 |= color | form | (160);
  sp->attribute1 &= 0x3FFF;
  sp->attribute1 |= size | (240);
}
//========================================================================
void SpriteChange(u16 num, u16 ch){
  OAMEntry* sp = (OAMEntry*)OAMmem;      // OAM
  sp += num;                             // OAM̍\Pʂ8byte
  sp->attribute2 &= 0xFC00;
  sp->attribute2 |= ch;
}
//========================================================================
void SpriteSetChr(u16 *img,u32 size){
  u16 *OAMDataAdr = OAMdata;
  int i;

  for(i=0; i<size/2; i++){
    //uprintf("src=0x%x dest=0x%x %x %x\n",img, OAMDataAdr, size/2, i);
    //dprint(res_printf);
    *OAMDataAdr++ = *img++;
  }
}
//========================================================================
void SpriteSetPal16(u16 *pal){
  u16* OBJPaleAdr = OBJpal;
  int i;
  
  for(i=0; i<16; i++){
    dprintf("src=0x%x dest=0x%x\n",pal, OBJPaleAdr);
    *OBJPaleAdr++ = *pal++;
  }
}
//========================================================================
void SpriteSetPal256(u16 *pal){
//  u16* OBJPaleAdr = OBJpal;
}
//========================================================================
int dprintf(char *fmt, ...){
	char s[256];
	va_list marker;
	va_start(marker, fmt);
	int r = vsprintf(s, fmt, marker);
	va_end(marker);
	dprint(s);
	return r;
}
//========================================================================
//VBÃfobNlogo͂
void dprint(u8 *sz){
  const u32 port=0xc0ded00d;
//	"ldr r0, =0xc0ded00d\n"
	asm volatile(
	"mov r2, %0\n"
	"mov r0, %1\n"
	"mov r1, #0\n"
	"and r0, r0, r0\n"
  :
  :
  "r" (sz) ,"r" (port):
  "r0", "r1", "r2");
}
//========================================================================
void SoundInitialize(){
  //܂̂ƂPCMt
  SOUNDCNT_X  = ENABLE_SOUND_MASTER;
  SOUNDCNT_L  = 0;
  SOUNDCNT_H  = 0;
  SOUNDCNT_H |= (DSOUND_A_TIMER0 | ENABLE_DSOUND_A_RIGHT | ENABLE_DSOUND_A_LEFT | DSOUND_A_FULL_OUTPUT);
  SOUNDCNT_H |= (RESET_DSOUND_A);
}
//========================================================================
void SoundSetData(s8 *buf, u32 size){
  wavedata= buf;
  wavecnt = size;
}
//========================================================================
void SoundStart()
{
  REG_TM0CNT   &= ~TM_ENABLE;
  REG_DM1CNT_H &= ~DMA_TRANSFER_ON;
  
  REG_DM1CNT_H = 0;
  REG_DM1SAD   = (u32)(wavedata);
  REG_DM1DAD   = (u32)(FIFO_A);
  REG_DM1CNT_H = (DMA_SIZE_32 | DMA_TRANSFER_OFF | DMA_TIMING_FIFO | 
                  DMA_REPEAT_ON | DMA_SAD_INC | DMA_DAD_FIX | DMA_INTR_ON);

  REG_TM0D = (u16)(-1520);
  REG_TM0CNT = TM_ENABLE | TM_FREQ_PER_1;

  REG_DM1CNT_H|= DMA_TRANSFER_ON;
}
//========================================================================
void *_malloc(u32 size){
  void *ptr;
  
  ptr=malloc(size);
  
  if(ptr!=0){
    dprintf("_malloc ptr=0x%x size=0x%x \n",size,(u32)ptr);
    return(ptr);
  }
  
  REG_IME = IRQ_MASTER_OFF;
  dprintf("vIG[:EWRAMȂȂ܂B\n");
  dprintf("_malloc ptr=0x%x \n",(u32)ptr);
  while(1){};
}
//========================================================================
void _mfree(void *ptr){
  dprintf("mfree ptr=0x%x\n",(u32)ptr);
  free(ptr);
}
//========================================================================
// ExtendROM(iwram_overlay_lma) TinyFileSystem
void exttfs_init(void){
    exttfs=&__ewram_overlay_lma;
    dprintf("_exttfs_init ptr=0x%x;\n",(u32)exttfs);
}

u8 *exttfs_GetDataOffset(u32 offset){
  exttfs=&__ewram_overlay_lma;
  exttfs+=offset;
  dprintf("_exttfs_GetDataOffset ptr=0x%x;\n",(u32)exttfs);

  return(exttfs);
}

void exttfs_SetManualAddress(u8 *data){
  exttfs=data;
}

u8 *exttfs_GetDataAddr(void){
  return(exttfs);
}

void exttfs_SkipData(u32 size){
  exttfs+=size;
}

u8 exttfs_readu8(void){
  u8 ret;
  ret=*exttfs;
  exttfs++;
  return(ret);
}

u16 exttfs_readu16(void){
  u16 ret;
  ret=*(u16*)exttfs;
  exttfs+=2;
  return(ret);
}

u32 exttfs_readu32(void){
  u32 ret;
  ret=*(u32*)exttfs;
  exttfs+=4;
  return(ret);
}
//========================================================================
u8 *exttfs_fopenLZ77(u32 offset, u32 size){
  u8 *buf;

  buf = _malloc(size);
  LZ77UnCompWram((void*)exttfs_GetDataOffset(offset), (void*)buf);

  return(buf);
}
//========================================================================
// 1bittHgf[^16hbg\
void Set1block1bit(u8 font,int x,int y,u16 color){
	u16* screen = VideoBuffer;

	screen[(y*240)+(x+0)] = (font & 0x80) ? color : screen[(y*240)+(x+0)];
	screen[(y*240)+(x+1)] = (font & 0x40) ? color : screen[(y*240)+(x+1)];
	screen[(y*240)+(x+2)] = (font & 0x20) ? color : screen[(y*240)+(x+2)];
	screen[(y*240)+(x+3)] = (font & 0x10) ? color : screen[(y*240)+(x+3)];
	screen[(y*240)+(x+4)] = (font & 0x08) ? color : screen[(y*240)+(x+4)];
	screen[(y*240)+(x+5)] = (font & 0x04) ? color : screen[(y*240)+(x+5)];
	screen[(y*240)+(x+6)] = (font & 0x02) ? color : screen[(y*240)+(x+6)];
	screen[(y*240)+(x+7)] = (font & 0x01) ? color : screen[(y*240)+(x+7)];
}
//========================================================================
// tHgf[^̐擪numberԖڂ̂P\
void Mode3PutAscii(u8 x, u8 y, u16 num, u16 col){
//	int index = (num/32*64 + num%32);

//	Set1block1bit(screen,(u8*)&HANKAKU_FONT[index*8        ],x1  ,y1  ,color);
//	Set1block1bit(screen,(u8*)&HANKAKU_FONT[index*8   +32*8],x1  ,y1+8,color);
}
//========================================================================
// tHgf[^̐擪numberԖڂ̂P\
void Mode3PutChar(u8 x, u8 y, u16 num, u16 col){
	u32 index = num * FONTSJIS.size;
	u8  i,j;

	for(j=0; j<FONTSJIS.cy; j++){
		for(i=0; i<FONTSJIS.cx; i++){
			Set1block1bit(FONTSJIS.Offset[index++],
						    x+i*8, y+j, col);
		}
	}
}
//========================================================================
// Spꕶ\
void Mode3PutSJIS(u8 x, u8 y, u8* chr, u16 col){
	u16 code = (chr[1]*256) + chr[0]; //tɂƂ
	u16 i;

	for(i=0; i<FONTSJIS.cnt; i++){
		if(code == FONTSJIS.Code[i])
			break;
	}

	if(i<FONTSJIS.cnt){
		i -= (i/0x21);
		Mode3PutChar(x,y,i,col);
	}
}
//========================================================================
void Mode3Print(u8 x,u8 y,u8 *text,u16 col){
	u16 i=0;
	while( text[i] != '\0' ){
		
		if( text[i] >= 0x80 ){  //Sp
			Mode3PutSJIS(x,y,&text[i],col);
			i+=2; x+=14;
		}else{                  //p
			Mode3PutAscii(x,y,text[i],col);
			i+=1; x+=1;
		}
	}
}
//========================================================================
void Mode3PrintLength(u16* screen,int x,int y,u8* texts,u16 color,int length){
	u16 i=0;
	int n=0;
	
	while( texts[i] != '\0' ){
		
		if( texts[i] >= 0x80 ){ // Sp
			Mode3PutSJIS(x,y,&texts[i],color);
			i+=2;x+=16;
			n++;
		}else{ // p
			Mode3PutAscii(x,y,texts[i],color);
			i+=1;x+=8;
			n++;
		}
		if(n > length-1) break;
		if(x > 240-9){x=0;y+=16;}
	}
}
//========================================================================
// l̕\
void Mode3PrintNum(u16* screen,int x,int y,int num,u16 color){
	u16 i=0;
	char text[10];
	
	//sprintf(text,"%d",num);
	
	while( text[i] != '\0' ){
		
		Mode3PutAscii(x,y,text[i],color);
		i+=1;x+=8;
		if(x > 240-9){x=0;y+=16;}
	}
}
//========================================================================
